// ==========================================================================
// $Source: /home/cvs/Taktuk2/NetworkCore/src/acom_error.h,v $
// Copyright(c)'2001 by Apache Team
// see the copyright file
// Author: T. Gautier
// [note]: based on giverror.h
// [note]: class hierarchy for A0++ is derived from ANSI/ISO C++ hierarchy.
// ==========================================================================
#ifndef _ACOM_NET_ERROR_H_ 
#define _ACOM_NET_ERROR_H_
#include <inuk/acom_netconfig.h>
#include <inuk/acom_ns.h>
#include <new>         // - get bad_alloc ???
#include <iostream>
#include <string>

extern "C" {
#include <errno.h>
#include <string.h>   // - strerror
}

namespace ACOM_NET_NAMESPACE {

// glue to PTH eror hierarchy
typedef RuntimeError Runtime; 

// glue to the glue to PTH error hierarchy.....
typedef PTH::BadAlloc BadAlloc;

// glue to the glue to PTH error hierarchy.....
typedef PTH::Range Range;

// glue to the glue to PTH error hierarchy.....
typedef PTH::Logic Logic;

// glue to the glue to PTH error hierarchy.....
typedef PTH::InvalidArgument InvalidArgument;

// glue to the glue to PTH error hierarchy.....
typedef PTH::Length Length;

// glue to the glue to PTH error hierarchy.....
typedef PTH::OutOfRange OutOfRange;

} // - namespace ACOM_...


// -- Two macros to convert __LINE__ to a string...
#define ACOM_XVALTOSTR(msg)     #msg
#define ACOM_VALTOSTR(msg)     ACOM_XVALTOSTR(msg)


// -- Debug macro: assert and trace
#  define ACOM_ASSERT(cond, msg)       \
    if (!(cond))        \
       ACOM_NET_NAMESPACE::throwit( ACOM_NET_NAMESPACE::RuntimeError(\
           msg "\tFile:" __FILE__ ", Line:" ACOM_VALTOSTR(__LINE__)));


#if defined(DEBUG) 
#define ACOM_DEBUG_MACRO
#endif

#ifdef ACOM_DEBUG_MACRO
#  define ACOM_ASSERT_DEBUG(cond, msg)       \
    if (!(cond))        \
       ACOM_NET_NAMESPACE::throwit( ACOM_NET_NAMESPACE::RuntimeError(\
           msg "\tFile:" __FILE__ ", Line:" ACOM_VALTOSTR(__LINE__)));

#  define ACOM_TRACE(level, msg)   \
      if (level >= ACOM_DEBUG_LEVEL)   \
         std::cout << msg "\tFile:" __FILE__ ", Line:" ACOM_VALTOSTR(__LINE__);
#  define ACOM_DEBUG1(inst) { ACOM_NET_NAMESPACE::Error__mprint->lock(); inst; ACOM_NET_NAMESPACE::Error__mprint->unlock(); }
#else
#  define ACOM_TRACE(level, msg)   
#  define ACOM_DEBUG1(x)   
#  define ACOM_PRINT(expr)       
#  define ACOM_ASSERT_DEBUG(cond, msg) 
#endif

#endif
