// ==========================================================================
// $Source: /home/cvs/Taktuk2/NetworkCore/src/acom_router.h,v $
// Copyright(c)'2001 by Apache Team
// Authors: Jacques Briat, Thierry Gautier, Cyrille Martin
// ==========================================================================
#ifndef _ACOM_ROUTER_H_
#define _ACOM_ROUTER_H_

#ifndef WIN32
#include <inuk/acom_netconfig.h>
#endif
#include <inuk/acom_comerror.h>
#include <inuk/acom_iovect.h>
#include <inuk/acom_service.h>
#include <inuk/acom_network.h>
#include <inuk/acom_types.h>
#include <vector>

//@Include: acom_config.h acom_comerror.h acom_types.h
// A0 namespace
namespace ACOM_NET_NAMESPACE {

// ---------------------------------------------------------------------------
// Type of global node identifier
// ---------------------------------------------------------------------------
typedef uint16_t GlobalNodeNo;

// ---------------------------------------------------------------------------
// Router class
// ---------------------------------------------------------------------------
/**@name Router
*/
class Router {
public:
  Router();
  
  ~Router();
  
  /** Initialisation of the router from ...
  */
  void init ( int* argc, char** argv[] );

  /** Second stage of the initialisation process.
  */
  void initcommit ();

  /** Terminate the net...
  */
  void terminate ();

  /** Register a new network to the router
  */
  void register_network( Network* net ) throw ();

  /** Get the route to the node global identifier node dest_node.
   The route is a network and a node in this network.
  */
  void get_route( Network*& net, Network::LocalNodeNo& node, 
                  GlobalNodeNo dest_node ) throw()
  {
    direction& dir= _routes[dest_node];
    net  = dir.first;
    node = dir.second;
  }

  /**
  */
  static Router global;

private: 
  typedef std::pair<Network*,NodeNo> direction;
  std::vector<Network*>  _nets;    // all networks
  std::vector<direction> _routes;  // all routes
}; // -- end class Router


}  // end namespace ATH...
#endif 
