// ==========================================================================
// $Source: /home/cvs/Taktuk2/NetworkCore/src/acom_types.h,v $
// Copyright(c)'2001 by Apache Team
// Authors: Jacques Briat, Thierry Gautier
// $Id: acom_types.h,v 1.1.1.1 2004/06/29 13:32:12 martinc Exp $
// ==========================================================================
#ifndef _ACOM_TYPES_H_
#define _ACOM_TYPES_H_

#ifndef WIN32
#include <inuk/acom_netconfig.h>
#endif

//@Include: acom_netconfig.h

// A0 namespace
namespace ACOM_NET_NAMESPACE
{

#if (SIZEOF_CHAR == 1)
  typedef signed char            int8_t;
  typedef unsigned char          uint8_t;
#else
#warning "size of char != 1"
#endif

#if (SIZEOF_SHORT == 2)
  typedef signed short           int16_t;
  typedef unsigned short         uint16_t;
#else
#warning "size of short != 2"
#endif

#if (SIZEOF_INT == 4)
  typedef int                    int32_t;
  typedef unsigned int           uint32_t;
#elif (SIZEOF_LONG == 4)
  typedef long                   int32_t;
  typedef unsigned long          uint32_t;
#endif

#if (SIZEOF_LONG_LONG == 8)
  typedef long long            int64_t;
  typedef unsigned long long   uint64_t;
#else
#warning "Undefined 64 bits integer, use 32bits"
  typedef long long            int64_t;
  typedef unsigned long long   uint64_t;
#endif


//---------------------------------
/// Basic type definition related to a network type
//---------------------------------
/**@name Basic type definition
 */
//@{
  ///
typedef uint32_t  NodeNo;
  ///
typedef uint32_t  UserTag;
  ///
typedef int32_t   DataSize;
  ///
typedef int32_t   ComNo;
  ///
typedef int32_t   PortNo;
//@}

}  // end namespace ACOM_NET_NAMESPACE 
#endif /* _ACOM_TYPES_H_ */
