// ==========================================================================
// $Source: /home/cvs/Taktuk2/Pthread/src/pth_fwd.h,v $
// Copyright(c)'2001 by Apache Team
// see the copyright file for more information
// Author: J Briat T.Gautier
// Header file for Inuktitut/Network
// ==========================================================================
/*!
\file  
\brief this file fix the PTH namespace  for Inuktitut0  INRIA.
\author  J. Briat T. Gautier 
\date 2001
*/
// Fix the the name of the package 
#ifndef _PTH_FWD_H 
#define _PTH_FWD_H

#include <inuk/pth_ns.h>
#include <inuk/pth_dep.h>

#if defined(PTH_USE_PTHREAD_DARWIN) || defined(PTH_USE_PTHREAD_LINUX) || defined(PTH_USE_PTHREAD_IRIX) || defined(PTH_USE_PTHREAD_LINUX_IA64)
#include <pthread.h>
#endif


// -- Definition of basic types
namespace PTH
{ 
  typedef pthread_mutex_t PMutex;
  typedef pthread_cond_t  PCondition;
  typedef pthread_t ThreadId;

  /* PTH c++ definitions */
  class Mutex;
  class Condition;
  class Thread;

}

#endif
/*! 
\namespace PTH 
\brief All the Inuktitut0 Posix thread stuff is in this namespace. 
*/
