#ifndef _PTH_MACRO_H_
#define _PTH_MACRO_H_

/*!
\file  
\brief  Some useful macros  to build log or error messages  
\author  J. Briat T. Gautier 
\date 2001

*/

#include <string>

/*! \def _XCONCAT (x, y)
\brief Intermediate working macro to concatenate __LINE__ to an identifier
*/
#define _XCONCAT(XX,YY)     XX ## YY

/*! \def _CONCAT(x , y )
\brief Top level macro to concatenate __LINE__ to an identifier
*/
#define _CONCAT(XX,YY)     _XCONCAT(XX,YY)



/*! \def _XVALTOSTR
\brief Intermediate working macro  to aid converting a decimal to a string
*/
#define _XVALTOSTR(msg)     #msg

/*! \def _VALTOSTR(msg)
\brief Top level macro to convert a decimal to a string
*/
#define _VALTOSTR(msg)     _XVALTOSTR(msg)

/*! \def SUFX(msg)
\brief append file name and line number to the argument string
*/
#define SUFX(msg)  msg"\tFile:" __FILE__ ", Line:"_VALTOSTR(__LINE__)


#endif
