/*
 * The contents of this file are subject to the Dyade Public License,
 * as defined by the file DYADE_PUBLIC_LICENSE.TXT
 *
 * You may not use this file except in compliance with the License. You may
 * obtain a copy of the License on the Dyade web site (www.dyade.fr).
 *
 * Software distributed under the License is distributed on an "AS IS" basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License for
 * the specific terms governing rights and limitations under the License.
 *
 * 
 * 
 *
 * The Initial Developer of the Original Code is Dyade. The Original Code and
 * portions created by Dyade are Copyright Bull and Copyright INRIA.
 * All Rights Reserved.
 */
/* Copyright (c) 1997 by Groupe Bull. Read the COPYRIGHT file. */
/* $Id: */
/* Author: Cyrille.Martin@imag.fr */

/* Cyrille Martin */
/* laboratoire ID-IMAG, BULL*/
/* Projet LIPS action DYADE*/
/* 07/06/2001 */

#ifndef __BARRIER_H
#define __BARRIER_H

#include <inuk/acom>
#include <pthread.h>
#include <inuk/taktuk/taktuknetwork.h>
#include <time.h>

#define TIMEOUT 6000

class Barrier:public acom::ServiceAM
{
 public:
  Barrier(){
	_id=0;
	_rank=0;
	_count_node=0;
	_count=0;
	_net=0;
	time_out.tv_sec=TIMEOUT;
	time_out.tv_nsec=0;
	acom::Service::Manager.bind(acom::ServiceManager::TAKTUK_LNS,3, (acom::Service*)this);
//	_countdown.init(0);
//	pthread_mutex_init(&count_mutex,NULL);
//	pthread_cond_init(&count_cond,NULL);  
  }
  void init(int rank,int count_node,Taktuk::Network* net){
	_rank=rank;
	_count_node=count_node;
	//_count=0;
	_net=net;
        count_mutex.init();
        count_cond.init();
  }
  ~Barrier(){
//	pthread_mutex_destroy(&count_mutex);
//	pthread_cond_destroy(&count_cond); 
        count_mutex.destroy();
        count_cond.destroy();
  }
  void call(acom::ComFailure::Code error_no,
			acom::Network::Receipt* receipt,
			acom::Network::Header* header,
			acom::IOVectEntry* vector,
			acom::IOVectSize count,
      void* ctxt
  ) throw(acom::ComFailure);
  int sync();
 private:
  void waitfor(int);  
  int _rank;
  int _count_node;
  typedef unsigned int id_t;
  timespec time_out;
  id_t _id;
  Taktuk::Network* _net;
  int _count;
//  pthread_mutex_t count_mutex;
//  pthread_cond_t count_cond;
    PTH::Mutex count_mutex;
    PTH::Condition count_cond;
//  PTH::CountDown _countdown;
  void ack();
};


#endif /* __TAKTUKBARRIER_H */
