#ifndef MPUT_FILE_WRITER_H
#define MPUT_FILE_WRITER_H

#include "mput.h"

extern int current_write_buffer;
extern int current_write_position;


/**
Fonction destinee a etre utilisee comme un thread independant et prenant en
parametre une chaine de caractere contenant le repertoire cible
*/
void * file_writer(void * target_directory);

/**
Initialisation du file_writer
*/
void init_file_writer();

/**
Retourne la taille d'un nom de fichier lut dans le buffer

Valeur de retour : longueur du nom de fichier inclus le caractere d'arret null
*/
uint32_t get_file_name_size();

/**
Recupere le nom de fichier de taille file_name_size depuis le buffer
et le stocke dans file_name

Parametres : tableau de caractere d'au moins file_name_size caracteres
             taille du nom du fichier incluant le caractere null
*/
void get_file_name(char * file_name, int file_name_size);

/**
Recupere les stats du fichier depuis le buffer

Parametre : pointeur sur une structure "struct stat" qui sera mise a jour
*/
void get_stat(struct stat * file_stat);

/**
Recupere les donnees du fichier depuis le buffer et les ecrit sur le disque

Parametres : descripteur du fichier
             stats du fichier
*/
int write_data(int fd, struct stat * file_stat);

/**
Recupere un fichier depuis le buffer et le recopie a l'emplacement
directory et renvoie -1 si il n'y a plus de fichier a lire

Parametres : repertoire cible

Valeur de retour : -1 : plus de fichier a lire
                   0  : repertoire lu
                   1  : fichier lu
*/
int file_write(const char * target_directory);

/**
Echange le buffer d'ecriture
*/
int switch_write_buffer();

#endif
