#ifndef MPUT_NETWORK_H
#define MPUT_NETWORK_H

#include "mput.h"
/**
Connect to the target at target->addr target->port
et met a jour le champ target->sockfd

Valeur de retour : file descriptor de la socket cree
*/
int connect_to(struct target_mput * target);

/**
Recupere la liste desadresses IP de la machine

Parametre : type des adresses AF_INET ou AF_INET6
Valeur de retour : tableau de tableau de caracteres
contenant les adresses ip et termine par un tableau vide
*/
char ** my_addrs(int *addrtype);

/**
Recupere la premiere adresse ip de la machine

Parametre : chaine de caractere de MAXADDRSIZE 
qui contiendra la version literalle de l'adresse

Valeur de retour : adresse ip au format host
*/
uint32_t get_ip_addr(char *ip_addr_str);

/**
Cree une socket TCP en listen avec un port ephemere

Parametre  : pointeur sur une structure sockaddr_in
qui sera mise a jour

Valeur de retour : file descriptor de la socket cree
*/
int create_listening_socket(struct sockaddr_in *servaddr);

/**
Recupere le port associe a une socket

Parametres : pointeur sur une structure sockaddr_in
qui sera mise a jour
             descripteur de la socket dont on cherche le port

Valeur de retour : port de la socket au format host
*/
uint16_t get_port_assigned(struct sockaddr_in *servaddr,int listenfd);

#endif
