#ifndef MPUT_UTILS_H
#define MPUT_UTILS_H

#include "mput.h"

/* path max du fichier de conf */
#define MAXPATH 1024
#define NFSPATH "/users/huron/videau"
#define MPUTCONFFILE "mput.conf"

/**
Affiche le manuel du mput avec les options et les arguments
*/
void print_usage(void);

/**
Parse la ligne de commande de mput
et affecte les variables globales correspondantes

Parametres : argc et argv de mput

Valeur de retour : index du prmier argument dans la ligne de commande
*/
int parse_optional_arguments(int argc, char **argv);

/**
Verifie si les arguments passes a la fonction:
au moins 2

Parametres : index du premier argument dans argv, argc et argv de mput
*/
void verify_arguments(int index, int argc, char** argv);

/**
Compare deux structures de type target et retourne le resultat
de la comparaison

Parametres : pointeurs sur les structures a comparer

Valeur de retour : -1 : target1 < target2
                    0 : target1 == target2
                    1 : target1 > target2
*/
int compare_targets(struct target_mput * target1,struct target_mput * target2);

/**
Cree une liste triee de target en utilisant
les fichiers de configuration

Valeur de retour : liste des target triees par ordre croissant
termine par une target nulle
*/ 
struct target_mput * create_host_sorted_list(struct target_mput **input, int target_count );

/**
Affiche une target a l'ecran

Parametre : pointeur sur la target a afficher 
*/
void print_target(struct target_mput * target);

/**
Affiche une liste de target a l'ecran

Parametre : liste de target a afficher terminee par une target nulle
*/
void print_targets(struct target_mput * targets);

/**
Trie une liste de target en utilisant l'algorithme quick sort

Parametre : liste de target a trier terminee par une target nulle
*/
void quick_sort_targets(struct target_mput * targets);

/**
Trouve les proches de la target 'me' dans la liste fournie
et met a jour les variables globales bbrother lbrother et father

Parametre : liste de target triee terminee par une target nulle
*/
void find_relatives(struct target_mput * targets);

/**
Affiche les target me bbrother lbrother et father
*/
void print_relatives();

/** 
Obtient une liste d'hotes cibles ou on enverr/renverra les donnees

Valeur de retour : retourne une liste d'hotes terminee par un hote
vide
*/
struct target_mput * get_targets(struct target_mput * hosts_list);
/**
Envoie la liste de fichier "sources" au cibles designees par "targets"

Parametres : liste d'hotes terminees par un hote vide

             liste de fichier (voir definition de sources)

*/
void send_receive_files(struct target_mput * targets, struct files * sources, char * target_directory);

#endif
