/* Cyrille Martin */
/* laboratoire ID-IMAG, BULL*/
/* Projet LIPS action DYADE*/
/* 07/06/2001 */
#ifndef _TAKTUK_ROUTER_H
#define _TAKTUK_ROUTER_H
#include <inuk/taktuk/taktukconf.h>
#include <inuk/taktuk/CoreTCP.h>
#include <inuk/pth>
#include <inuk/acom>

class taktuk_router : public routertcp
{
 public:
  taktuk_router(acom::Network* net): routertcp(){_net=net;initAllocators();}
	~taktuk_router(){}
 protected:
  int process(InfoTCPnet::link* l,int localID); 

  /** iovect entries in a cell
  */
  static const int _nb_entries=10; // iovect entries in a cell
  /** packed block size
  */
  static const int _block_sz = 1500; // packed block size
  /** Logical clock for timestamping request
  */
  /** size of cached free blocks
  */
  static const int _block_threshold=5; // size of cached free blocks
  /** size of cached free blocks
  */
  static const int _iovect_threshold=5; // size of cached free blocks
  /** size of cached free blocks
  */
  static const int _request_threshold=5; // size of cached free blocks

  acom::ByteCellAllocator _bA;
  /** iovec allocator
  */
  acom::IOVectCellAllocator _iovA;

  void initAllocators(){
   _bA.init(_block_sz, _block_threshold  );
   _iovA.init(sizeof(acom::IOVectCell)+(_nb_entries*sizeof(acom::IOVectEntry)) ,
   _iovect_threshold    );
  }
 private:
   void bcast(InfoTCPnet::link* link,
				acom::Network::CallContext* cc,
				acom::IOVectEntry* iov,
				int32_t* iov_dsz,
				void* im_data);

	int clean_link(InfoTCPnet::link* link, int nbtoread)
	{
		int nbread=0;
		int data_to_read=nbtoread;
		for(;data_to_read>0;)
		{
			nbread=link->_sock->readn(receive_buffer,data_to_read>MAXBUF ? MAXBUF : data_to_read);
			if(nbread<=0)
			{
				return -1;
			}
			data_to_read-=nbread;
		}
		return 0;
	}
	
	acom::Network* _net;
  
};

#endif
